# Enable/disable features according to the type of distribution:
%if 0%{?fedora}
%global install_systemd 1
%global install_systemv 0
%global install_poms 1
%global require_maven 1
%endif

%if 0%{?rhel}
%global install_systemd 0
%global install_systemv 1
%global install_poms 0
%global require_maven 0
%endif

%if 0%{?ovirt_build_quick}
%global ovirt_build_gwt 0
%global ovirt_build_locales 0
%global __jar_repack 0
%endif
%if 0%{?ovirt_build_minimal}
%global ovirt_build_locales 0
%global EXTRA_BUILD_FLAGS -D gwt.userAgent=gecko1_8
%endif
%if 0%{!?ovirt_build_gwt:1}
%global ovirt_build_gwt 1
%endif
%if 0%{!?ovirt_build_locales:1}
%global ovirt_build_locales 1
%endif

# Settings
%global product_name Red Hat Storage Console
%global product_name_short RHS-C
%global user_description oVirt Manager

# Short names for engine directories:
%global engine_name ovirt-engine
%global engine_etc %{_sysconfdir}/%{engine_name}
%global engine_data %{_datadir}/%{engine_name}
%global engine_doc %{_docdir}/%{engine_name}
%global engine_ear %{engine_data}/engine.ear
%global engine_java %{_javadir}/%{engine_name}
%global engine_pki %{_sysconfdir}/pki/%{engine_name}
%global engine_jboss_modules %{engine_data}/modules

%global engine_state %{_localstatedir}/lib/%{engine_name}
%global engine_log %{_localstatedir}/log/%{engine_name}
%global engine_run %{_localstatedir}/run/%{engine_name}
%global engine_cache %{_localstatedir}/cache/%{engine_name}
%global engine_tmp %{_localstatedir}/tmp/%{engine_name}

%global restapi_war %{engine_ear}/restapi.war
%global root_war %{engine_ear}/root.war

# The name and ids of the engine user and group:
%global engine_user ovirt
%global engine_group ovirt
%global engine_gid 108
%global engine_uid 108

# The name and ids of the VDSM user and group:
%global vdsm_description Node Storage Manager
%global vdsm_user vdsm
%global vdsm_group kvm
%global vdsm_uid 36
%global vdsm_gid 36

# Macro to create an user:
# %1 user name
# %2 user id
# %3 primary group name
# %4 primary group id
# %5 description
# %6 home directory
%global create_user() \
getent group %3 >/dev/null || groupadd -r -g %4 %3; \
getent passwd %1 >/dev/null || useradd -r -u %2 -g %3 -c %5 -s /sbin/nologin -d %6 %1

# Macro to create the engine user and group:
%global create_engine_user \
%create_user %{engine_user} %{engine_uid} %{engine_group} %{engine_gid} "%{user_description}" %{engine_state}

# Macro to create the VDSM user and group:
%global create_vdsm_user \
%create_user %{vdsm_user} %{vdsm_uid} %{vdsm_group} %{vdsm_gid} "%{vdsm_description}" /var/lib/vdsm

%global make_common_opts \\\
	-j1 \\\
	BUILD_GWT=%{ovirt_build_gwt} \\\
	BUILD_LOCALES=%{ovirt_build_locales} \\\
	PACKAGE_NAME=%{name} \\\
	RPM_VERSION=%{version} \\\
	RPM_RELEASE=%{release} \\\
	DISPLAY_VERSION=%{version}-%{release} \\\
	ENGINE_NAME=%{engine_name} \\\
	LOCALSTATE_DIR=%{_localstatedir} \\\
	ENGINE_STATE=%{engine_state} \\\
	PREFIX=%{_prefix} \\\
	SYSCONF_DIR=%{_sysconfdir} \\\
	BIN_DIR=%{_bindir} \\\
	PID_DIR=%{_localstatedir}/run \\\
	DATAROOT_DIR=%{_datadir} \\\
	MAN_DIR=%{_mandir} \\\
	DOC_DIR=%{_docdir} \\\
	PYTHON=%{__python} \\\
	PYTHON_DIR=%{python_sitelib} \\\
	JAVA_DIR=%{_javadir} \\\
	MAVENPOM_DIR=%{_mavenpomdir} \\\
	PKG_SYSCONF_DIR=%{engine_etc} \\\
	PKG_DOC_DIR=%{engine_doc} \\\
	PKG_EAR_DIR=%{engine_ear} \\\
	PKG_PKI_DIR=%{engine_pki} \\\
	PKG_JBOSS_MODULES=%{engine_jboss_modules} \\\
	PKG_CACHE_DIR=%{engine_cache} \\\
	PKG_LOG_DIR=%{engine_log} \\\
	PKG_TMP_DIR=%{engine_tmp} \\\
	PKG_USER=%{engine_user} \\\
	PKG_GROUP=%{engine_group} \\\
	MVN=true \\\
	%{?BUILD_FLAGS:BUILD_FLAGS="%{BUILD_FLAGS}"} \\\
	%{?EXTRA_BUILD_FLAGS:EXTRA_BUILD_FLAGS="%{EXTRA_BUILD_FLAGS}"}

Name: rhsc
Version: 2.1.0
Release: 0.bb10%{?dist}
Summary: Management console for Gluster Storage
Group:  Storage/Management
License: ASL 2.0
URL: http://www.redhat.com/products/storage-server

# We build RHS-C in the MEAD environment, and that means that the
# sources are the artifacts previously built with maven:

Source0: root-2.1.0-scm-sources.zip
Source1: uicompat-2.1.0-tests.jar
Source2: uicompat-2.1.0.jar
Source3: uicompat-2.1.0.pom
Source4: webadmin-2.1.0.war
Source5: webadmin-2.1.0.pom
Source6: uicommonweb-2.1.0-tests.jar
Source7: uicommonweb-2.1.0.jar
Source8: uicommonweb-2.1.0-sources.jar
Source9: uicommonweb-2.1.0.pom
Source10: gwt-extension-2.1.0.jar
Source11: gwt-extension-2.1.0.pom
Source12: gwt-extension-2.1.0-sources.jar
Source13: gwt-extension-2.1.0-tests.jar
Source14: userportal-2.1.0.war
Source15: userportal-2.1.0.pom
Source16: webadmin-modules-2.1.0.pom
Source17: frontend-all-2.1.0.pom
Source18: frontend-2.1.0.jar
Source19: frontend-2.1.0-tests.jar
Source20: frontend-2.1.0.pom
Source21: gwt-common-2.1.0.jar
Source22: gwt-common-2.1.0-tests.jar
Source23: gwt-common-2.1.0.pom
Source24: webadmin-all-2.1.0.pom
Source25: build-tools-root-2.1.0.pom
Source26: interface-2.1.0.pom
Source27: restapi-types-2.1.0.jar
Source28: restapi-types-2.1.0.pom
Source29: restapi-types-2.1.0-tests.jar
Source30: common-parent-2.1.0.pom
Source31: restapi-definition-2.1.0.pom
Source32: restapi-definition-2.1.0.jar
Source33: restapi-definition-2.1.0-tests.jar
Source34: restapi-jaxrs-2.1.0-tests.jar
Source35: restapi-jaxrs-2.1.0.jar
Source36: restapi-jaxrs-2.1.0.pom
Source37: interface-common-jaxrs-2.1.0.pom
Source38: interface-common-jaxrs-2.1.0-tests.jar
Source39: interface-common-jaxrs-2.1.0.jar
Source40: restapi-webapp-2.1.0.pom
Source41: restapi-webapp-2.1.0.war
Source42: restapi-parent-2.1.0.pom
Source43: vdsbroker-2.1.0.pom
Source44: vdsbroker-2.1.0-tests.jar
Source45: vdsbroker-2.1.0.jar
Source46: scheduler-2.1.0-client.jar
Source47: scheduler-2.1.0.pom
Source48: scheduler-2.1.0.jar
Source49: dependencies-2.1.0-modules.zip
Source50: dependencies-2.1.0.jar
Source51: dependencies-2.1.0.pom
Source52: dependencies-2.1.0-tests.jar
Source53: dbscripts-2.1.0.pom
Source54: tools-2.1.0-modules.zip
Source55: tools-2.1.0.pom
Source56: tools-2.1.0-tests.jar
Source57: tools-2.1.0.jar
Source58: bll-2.1.0.jar
Source59: bll-2.1.0.pom
Source60: bll-2.1.0-client.jar
Source61: searchbackend-2.1.0.pom
Source62: searchbackend-2.1.0-modules.zip
Source63: searchbackend-2.1.0-sources.jar
Source64: searchbackend-2.1.0.jar
Source65: searchbackend-2.1.0-tests.jar
Source66: manager-2.1.0.pom
Source67: utils-2.1.0-tests.jar
Source68: utils-2.1.0.jar
Source69: utils-2.1.0-modules.zip
Source70: utils-2.1.0.pom
Source71: dal-2.1.0.pom
Source72: dal-2.1.0.jar
Source73: dal-2.1.0-modules.zip
Source74: dal-2.1.0-tests.jar
Source75: backend-2.1.0.pom
Source76: manager-modules-2.1.0.pom
Source77: common-2.1.0-tests.jar
Source78: common-2.1.0.jar
Source79: common-2.1.0.pom
Source80: common-2.1.0-sources.jar
Source81: common-2.1.0-modules.zip
Source82: root-war-2.1.0.pom
Source83: root-war-2.1.0.war
Source84: compat-2.1.0.jar
Source85: compat-2.1.0-sources.jar
Source86: compat-2.1.0.pom
Source87: compat-2.1.0-modules.zip
Source88: compat-2.1.0-tests.jar
Source89: engine-server-ear-2.1.0.ear
Source90: engine-server-ear-2.1.0.pom
Source91: checkstyles-2.1.0.pom
Source92: checkstyles-2.1.0-tests.jar
Source93: checkstyles-2.1.0.jar
Source94: jboss-modules-maven-plugin-1.0.jar
Source95: jboss-modules-maven-plugin-1.0-tests.jar
Source96: jboss-modules-maven-plugin-1.0.pom
Source97: root-2.1.0.pom
Source98: ovirt-checkstyle-extension-2.1.0.jar
Source99: ovirt-checkstyle-extension-2.1.0-tests.jar
Source100: ovirt-checkstyle-extension-2.1.0.pom

BuildArch: noarch

# Build time requirements:
BuildRequires: java-devel
BuildRequires: jpackage-utils
BuildRequires: make
%if %{require_maven}
BuildRequires: maven
%endif
BuildRequires: unzip

# Run time requirements (most of these requirements should be
# moved to the subpackages):
Requires: bind-utils
Requires: cracklib-python
Requires: httpd
Requires: java-1.7.0-openjdk >= 1:1.7.0.9-2.3.3.2
Requires: java
Requires: jpackage-utils
Requires: mod_ssl
Requires: ntp
Requires: openssl
Requires: policycoreutils-python
Requires: python-cheetah
Requires: ovirt-host-deploy-java
Requires: yum-plugin-versionlock
Requires: rhsc-cli

# For local database:
Requires: postgresql-server >= 8.4.7

# Require JBoss EAP 6:
Requires: jbossas-standalone
Requires: jbossas-bundles
Requires: jbossas-modules-eap

%if %{install_systemd}
BuildRequires: systemd
%endif

# We can't require exactly the same version and release of the
# setup package because it needs to be updated independely as part
# of the update process implemented in the engine-upgrade script:
Requires: %{name}-setup >= %{version}-%{release}

# Require the subpackages so that everything is installed when the
# main package is installed:
Requires: %{name}-backend = %{version}-%{release}
Requires: %{name}-restapi = %{version}-%{release}
Requires: %{name}-tools = %{version}-%{release}
Requires: %{name}-dbscripts = %{version}-%{release}
Requires: %{name}-webadmin-portal = %{version}-%{release}

# Require other tool packages:

# Require virtio-win as vfd resource.
#Requires: virtio-win >= 1.6.3-3

Requires: rhsc-log-collector

# Require the documentation package:
#Requires: %{name}-doc >= 3.1.0
 
# Make sure that obsolete subpackages are removed:
Obsoletes: %{name}-genericapi
Obsoletes: %{name}-notification-service
Obsoletes: %{name}-tools-common
Obsoletes: %{name}-config

%description
Red Hat Storage is a feature-rich storage management
system that provides advanced capabilities for managing 
Red Hat storage infrastructure.


%package backend
Summary: Engine core of %{product_name_short}
Group: Storage/Management
Requires: %{name} = %{version}-%{release}
Requires: java
Requires: python-daemon
Requires: openssh
Requires: openssl
#Requires: novnc
Requires: logrotate

%if %{install_systemd}
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
%endif


%description backend
The backend engine of %{product_name_short}


%package restapi
Summary: RESTful API for %{product_name_short}
Group: Storage/Management
Requires: %{name} = %{version}-%{release}

%description restapi
The RESTful API for %{product_name_short}


%package setup
Summary: Setup and upgrade scripts for %{product_name_short}
Group: Storage/Management
Requires: %{name}
Requires: libxml2-python
Requires: lsof
Requires: nfs-utils
Requires: python-cheetah
Requires: yum
Requires: python-daemon
Requires: python-psycopg2
Requires: iproute
Requires: openssh
Requires: openssl
Requires: m2crypto
Requires: python-paramiko
Requires: otopi >= 1.0.0

%description setup
Setup and upgrade scripts for %{product_name_short}


%package dbscripts
Summary: Database scripts for %{product_name_short}
Group: Storage/Management
Requires: %{name} = %{version}-%{release}

%description dbscripts
Database scripts for %{product_name_short}


%package webadmin-portal
Summary: Web Admin Portal of %{product_name_short}
Group: Storage/Management
Requires: %{name} = %{version}-%{release}

%description webadmin-portal
The web administration interface to %{product_name_short}


%package tools
Summary: %{product_name_short} Tools
Group: Storage/Management
Requires: %{name} = %{version}-%{release}
Requires: java
Requires: python-daemon

%if %{install_systemd}
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
%endif

%description tools
%{product_name_short} Tools

%post tools
%if %{install_systemd}
%systemd_post ovirt-engine-notifier.service
%endif

%postun tools
%if %{install_systemd}
%systemd_postun ovirt-engine-notifier.service
%endif

%preun tools
%if %{install_systemd}
%systemd_preun ovirt-engine-notifier.service
%endif

%if %{install_systemv}
if [ $1 -eq 0 ] ; then
    service ovirt-engine-notifier stop > /dev/null 2>&1 || true
fi
%endif

%package websocket-proxy
Summary: %{product_name_short} Websocket Proxy
Group: Virtualization/Management
Requires: python-websockify
Requires: m2crypto
Requires: %{name}

%if %{install_systemd}
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
%endif

%description websocket-proxy
%{product_name_short} Websocket Proxy

%post websocket-proxy
%if %{install_systemd}
%systemd_post ovirt-websocket-proxy.service
%endif

%postun websocket-proxy
%if %{install_systemd}
%systemd_postun ovirt-websocket-proxy.service
%endif

%preun websocket-proxy
%if %{install_systemd}
%systemd_preun ovirt-websocket-proxy.service
%endif


%package setup-plugin-allinone
Summary: All-in-one plugin for %{product_name_short}'s setup
Group: Virtualization/Management
Requires: %{name}-setup
Requires: %{name}-sdk >= 3.1.0.6
Requires: openssh-server
Requires: ovirt-engine-cli
Requires: ovirt-host-deploy-offline
Requires: vdsm

%description setup-plugin-allinone
All-in-one plugin for %{product_name_short}'s setup


%prep

# We build RHS-C in the MEAD environment, and that means that the
# sources are archived with root based on repository name

%setup -q -T -b 0 -n rhs-engine

%build

make %{make_common_opts}

%install

rm -fr "%{buildroot}"

# Use the makefile to do the normal installation, after that we
# will need to replace jar files with links to their actual
# locations:
make %{make_common_opts} install DESTDIR=%{buildroot} MAVEN_OUTPUT_DIR=%{_sourcedir}

# Branded version of the configuration directory and utilities
ln -s %{engine_name} %{buildroot}%{_sysconfdir}/rhsc
for f in setup upgrade check-update cleanup config manage-domains; do
    ln -s engine-$f %{buildroot}%{_bindir}/rhsc-$f
done

# Branded man pages
echo ".so man8/engine-setup.8" > %{buildroot}%{_mandir}/man8/rhevm-setup.8
echo ".so man8/engine-upgrade.8" > %{buildroot}%{_mandir}/man8/rhevm-upgrade.8

install -dm 755 %{buildroot}/%{engine_state}/deployments
install -dm 755 %{buildroot}/%{engine_state}/content
install -dm 755 %{buildroot}/%{engine_log}/{host-deploy,notifier,engine-manage-domains}
install -dm 755 %{buildroot}/%{engine_cache}
install -dm 755 %{buildroot}/%{engine_run}/notifier

#
# Force TLS/SSL for selected applications.
#
for war in restapi webadmin; do
    sed -i \
        's#<transport-guarantee>NONE</transport-guarantee>#<transport-guarantee>CONFIDENTIAL</transport-guarantee>#' \
        "%{buildroot}%{engine_ear}/${war}.war/WEB-INF/web.xml"
done

# Move the jar files to the right directory and replace them with links:
install -dm 755 %{buildroot}%{engine_java}
while read lib_path
do
  java_path=%{engine_java}/`basename ${lib_path}`
  mv %{buildroot}/${lib_path} %{buildroot}/${java_path}
  ln -s ${java_path} %{buildroot}${lib_path}
done <<'.'
%{engine_ear}/bll.jar
%{engine_ear}/lib/vdsbroker.jar
%{engine_ear}/scheduler.jar
%{engine_jboss_modules}/org/ovirt/engine/core/common/main/common.jar
%{engine_jboss_modules}/org/ovirt/engine/core/compat/main/compat.jar
%{engine_jboss_modules}/org/ovirt/engine/core/dal/main/dal.jar
%{engine_jboss_modules}/org/ovirt/engine/core/searchbackend/main/searchbackend.jar
%{engine_jboss_modules}/org/ovirt/engine/core/tools/main/tools.jar
%{engine_jboss_modules}/org/ovirt/engine/core/utils/main/utils.jar
%{restapi_war}/WEB-INF/lib/interface-common-jaxrs.jar
%{restapi_war}/WEB-INF/lib/restapi-definition.jar
%{restapi_war}/WEB-INF/lib/restapi-jaxrs.jar
%{restapi_war}/WEB-INF/lib/restapi-types.jar
.

# Needed for compatibility if package is different than the directory structure
%if "%{name}" != "%{engine_name}"
ln -s "%{engine_name}" "%{buildroot}%{engine_java}/../%{name}"
%endif

# Register poms
%if !%{install_poms}
rm -fr "%{buildroot}%{_mavenpomdir}"
%else
for pom in %{buildroot}%{_mavenpomdir}/*.pom
do
  pomdir=`dirname "${pom}"`
  pom=`basename "${pom}"`
  jpppom="JPP.${pom}"
  mv "${pomdir}/${pom}" "${pomdir}/${jpppom}"
  artifact_id=`echo "${pom}" | sed -e 's/^%{name}-//' -e 's/\.pom//'`
  if [ -f "%{buildroot}%{engine_java}/${artifact_id}.jar" ]
  then
    %add_maven_depmap "${jpppom}" "%{name}/${artifact_id}.jar"
  else
    %add_maven_depmap "${jpppom}"
  fi
done
%endif

# Install the systemd files:
%if %{install_systemd}
install -dm 755 "%{buildroot}%{_unitdir}"
cp "%{buildroot}%{engine_data}/services/ovirt-engine.systemd" "%{buildroot}%{_unitdir}/ovirt-engine.service"
cp "%{buildroot}%{engine_data}/services/ovirt-engine-notifier.systemd" "%{buildroot}%{_unitdir}/ovirt-engine-notifier.service"
cp "%{buildroot}%{engine_data}/services/ovirt-websocket-proxy.systemd" "%{buildroot}%{_unitdir}/ovirt-websocket-proxy.service"
%endif

# Install System V init scripts:
%if %{install_systemv}
install -dm 755 "%{buildroot}%{_initddir}"
cp "%{buildroot}%{engine_data}/services/ovirt-engine.sysv" "%{buildroot}%{_initddir}/ovirt-engine"
cp "%{buildroot}%{engine_data}/services/ovirt-engine-notifier.sysv" "%{buildroot}%{_initddir}/ovirt-engine-notifier"
cp "%{buildroot}%{engine_data}/services/ovirt-websocket-proxy.sysv" "%{buildroot}%{_initddir}/ovirt-websocket-proxy"
%endif

# backward compatibly (pre-3.3.0)
# force rpm not to remove config files
# as these used to be %config
# these files are created empty in order to mark
# them as %ghost
touch %{buildroot}%{engine_etc}/notifier/notifier.conf
touch %{buildroot}%{engine_pki}/cacert.template
touch %{buildroot}%{engine_pki}/cert.template
touch %{buildroot}%{engine_pki}/database.txt
touch %{buildroot}%{engine_pki}/serial.txt

install -d "%{buildroot}%{_sysconfdir}/ovirt-engine-setup.conf.d"
cat > "%{buildroot}%{_sysconfdir}/ovirt-engine-setup.conf.d/10-packaging.conf" << __EOF__
[environment:default]
OVESETUP_APACHE/configureRootRedirectionDefault=bool:True
__EOF__
cat > "%{buildroot}%{_sysconfdir}/ovirt-engine-setup.conf.d/10-packaging-aio.conf" << __EOF__
[environment:default]
OVESETUP_AIO/enable=bool:True
__EOF__


%preun
#raw

if [ "$1" -eq 0 ]
then
    if [ -d "%{engine_pki}" ]; then
        #backup whole 'rhsc' dir into the backup dir with current date
        dest="%{engine_pki}/../%{engine_name}-backups/%{engine_name}-$(date +"%%Y_%%m_%%d_%%H_%%M_%%S")"
        mkdir -p "${dest}"
        cp -pR "%{engine_pki}" "${dest}"
    fi
fi



%preun backend
%if %{install_systemd}
%systemd_preun ovirt-engine.service
%endif

%if %{install_systemv}
if [ $1 -eq 0 ] ; then
    service ovirt-engine stop > /dev/null 2>&1 || true
fi
%endif

%postun

if [ "$1" -eq 0 ]
then
    rm -rf "%{engine_cache}"
    rm -rf "%{engine_pki}"

    if [[ -f %{_sysconfdir}/yum/pluginconf.d/versionlock.list ]]
    then
        sed -i '/%{name}/d' %{_sysconfdir}/yum/pluginconf.d/versionlock.list
    fi
fi



%postun backend
%if %{install_systemd}
%systemd_postun ovirt-engine.service
%endif


%pre
%create_engine_user


%pre backend
%create_engine_user


%pre setup
%create_vdsm_user


%pre tools
%create_engine_user


%post backend

# ovirt-engine<=3.2 created files at /usr among
# others are the jboss index files.
# we must remove these or application will not start.
find "%{engine_data}" -name '*.index' -exec rm "{}" \; || true

%if %{install_systemd}
%systemd_post ovirt-engine.service

# In 3.2 installations we did not handle postun section correctly.
# It means that the systemd daemon is not reloaded when 3.2 package
# is upgraded. This leads to an 'unstartable' ovirt-engine service
# when we upgrade to 3.3. As such, during the upgrade to 3.3 we need to
# reload the systemd daemon.

# TODO: remove when moving to 3.4

if [ $1 -eq 2  ] ; then
  %systemd_postun
fi
%endif


%files

# The main package owns most of the directories:
%dir %{engine_data}
%dir %{engine_data}/ovirt-isos
%dir %{engine_data}/db-backups
%dir %{engine_data}/scripts
%dir %attr(-, %{engine_user}, %{engine_group}) %{engine_log}
%dir %attr(-, %{engine_user}, %{engine_group}) %{engine_cache}

%dir %{engine_data}/conf

# Engine configuration files:
%dir %{engine_etc}
%config(noreplace) %{engine_etc}/engine.conf
%dir %{engine_etc}/engine.conf.d

# Services common
%{engine_data}/services/__init__.py*
%{engine_data}/services/config.py*
%{engine_data}/services/service.py*

# Branded version of the configuration directory:
%{_sysconfdir}/rhsc

# Jar files used by all the components:
%dir %{engine_java}
%{engine_java}/common.jar
%{engine_java}/compat.jar
%{engine_java}/utils.jar

# Needed for compatibility if package is different than the directory structure
%if "%{name}" != "%{engine_name}"
%{_javadir}/%{name}
%endif

# POM files:
%if %{install_poms}
%{_mavendepmapfragdir}/%{name}
%{_mavenpomdir}/JPP.%{name}-root.pom
%{_mavenpomdir}/JPP.%{name}-common.pom
%{_mavenpomdir}/JPP.%{name}-compat.pom
%{_mavenpomdir}/JPP.%{name}-utils.pom
%endif

# should be actually be
# at setup package, but as we use
# versionlock we cannot move these until
# 3.4
%{engine_data}/conf/engine-config-install.properties
%{engine_data}/conf/ovirt-engine-proxy.conf.in
%{engine_data}/conf/iptables.default
%{engine_data}/conf/nfs.sysconfig

# Documentation:
%doc LICENSE

# Branded version of the configuration directory:
%{_sysconfdir}/rhsc


%files backend

# Directory for binaries and scripts:
%dir %{engine_data}/bin
# Directory for ui plugins
%dir %{engine_data}/ui-plugins

# Files needed by the service:
%config %{_sysconfdir}/logrotate.d/ovirt-engine
%{engine_data}/services/ovirt-engine.*
%{engine_data}/services/ovirt-engine-logging.properties.in
%if %{install_systemd}
%{_unitdir}/ovirt-engine.service
%endif
%if %{install_systemv}
%{_initddir}/ovirt-engine
%endif

# Jar files:
%{engine_java}/bll.jar
%{engine_java}/dal.jar
%{engine_java}/scheduler.jar
%{engine_java}/searchbackend.jar
%{engine_java}/vdsbroker.jar

# POM files:
%if %{install_poms}
%{_mavenpomdir}/JPP.%{name}-backend.pom
%{_mavenpomdir}/JPP.%{name}-manager.pom
%{_mavenpomdir}/JPP.%{name}-manager-modules.pom
%{_mavenpomdir}/JPP.%{name}-tools.pom
%{_mavenpomdir}/JPP.%{name}-bll.pom
%{_mavenpomdir}/JPP.%{name}-dal.pom
%{_mavenpomdir}/JPP.%{name}-scheduler.pom
%{_mavenpomdir}/JPP.%{name}-searchbackend.pom
%{_mavenpomdir}/JPP.%{name}-vdsbroker.pom
%endif

# The state directory is owned by the backend, but not recursively, as
# some of its subdirectories are owned by other packages (backups, for
# example, has to be owned by the setup package):
%dir %attr(-, %{engine_user}, %{engine_group}) %{engine_state}

# Directories for the deployments and content files need to be owned by
# the engine user because the application server needs to write to them:
%attr(-, %{engine_user}, %{engine_group}) %{engine_state}/content
%attr(-, %{engine_user}, %{engine_group}) %{engine_state}/deployments

# Host deploy logs
%attr(-, %{engine_user}, %{engine_group}) %{engine_log}/host-deploy

# The backend owns the directory of the ear and most of its contents,
# but not all, as most of the web applications are owned by other
# subpackages:
%dir %{engine_ear}
%{engine_ear}/META-INF
%{engine_ear}/lib
%{engine_ear}/bll.jar
%{engine_ear}/scheduler.jar

# Root web application:
%{root_war}

# Sysprep files:
%config(noreplace) %{engine_etc}/sysprep

# Configuration files
%{engine_data}/conf/engine.conf.defaults

# PKI directories are owned by the engine user because it needs to
# create files inside:
%dir %attr(-, %{engine_user}, %{engine_group}) %{engine_pki}
%dir %attr(-, %{engine_user}, %{engine_group}) %{engine_pki}/certs
%dir %attr(-, %{engine_user}, %{engine_group}) %{engine_pki}/private
%dir %attr(-, %{engine_user}, %{engine_group}) %{engine_pki}/requests

# not owned by engine
%dir %{engine_pki}/keys

# PKI scripts:
%{engine_pki}/*.sh
%{engine_pki}/*.lock

# PKI configuration files:
%config(noreplace) %{engine_pki}/openssl.conf
%config(noreplace) %{engine_pki}/cacert.template.in
%config(noreplace) %{engine_pki}/cert.template.in

# backward compatibly (pre-3.3.0)
# force rpm not to remove pki files
# as these used to be %config
%ghost %config(noreplace) %{engine_pki}/cacert.template
%ghost %config(noreplace) %{engine_pki}/cert.template
%ghost %config(noreplace) %{engine_pki}/database.txt
%ghost %config(noreplace) %{engine_pki}/serial.txt

# Modules:
%{engine_jboss_modules}

%files setup

%config %{_sysconfdir}/ovirt-engine-setup.conf.d/10-packaging.conf

# Links to the main programs:
%{_bindir}/engine-setup
%{_bindir}/engine-setup-2
%{_bindir}/engine-cleanup-2
%{_bindir}/engine-upgrade
%{_bindir}/engine-check-update
%{_bindir}/engine-cleanup

# Branded versions of the links:
%{_bindir}/rhsc-setup
%{_bindir}/rhsc-upgrade
%{_bindir}/rhsc-check-update
%{_bindir}/rhsc-cleanup

# Python scripts:
%{engine_data}/scripts/basedefs.py*
%{engine_data}/scripts/engine_validators.py*
%{engine_data}/scripts/engine_firewalld.py*
%{engine_data}/scripts/setup_params.py*
%{engine_data}/scripts/setup_sequences.py*
%{engine_data}/scripts/setup_controller.py*
%{engine_data}/scripts/common_utils.py*
%{engine_data}/scripts/miniyum.py*
%{engine_data}/scripts/output_messages.py*
%{engine_data}/scripts/nfsutils.py*
%{engine_data}/scripts/engine-setup.py*
%{engine_data}/scripts/engine-cleanup.py*
%{engine_data}/scripts/engine-upgrade.py*
%{engine_data}/scripts/post_upgrade.py*

# DB-related tools
%{engine_data}/scripts/dbutils

# Setup
%{engine_data}/setup/bin/ovirt-engine-setup
%{engine_data}/setup/bin/ovirt-engine-remove
%{engine_data}/setup/bin/ovirt-engine-setup.env
%{engine_data}/setup/ovirt_engine_setup/*.py*
%{engine_data}/setup/plugins/*/*/*.py*

# Firewalld configuration
%{engine_data}/firewalld/base

# Man pages
%{_mandir}/man8/engine-config.*
%{_mandir}/man8/engine-setup.*
%{_mandir}/man8/engine-upgrade.*
%{_mandir}/man8/rhevm-setup.*
%{_mandir}/man8/rhevm-upgrade.*

# Configuration files
%{engine_data}/conf/ovirt-engine-root-redirect.conf.in
%{engine_data}/conf/version

# Plugins directory:
%dir %{engine_data}/scripts/plugins
%{engine_data}/scripts/plugins/example_plugin_000.py*

# Backups directory
%dir %attr(-, %{engine_user}, %{engine_group}) %{engine_state}/backups

%files setup-plugin-allinone
%{engine_data}/scripts/plugins/all_in_one_100.py*
%{engine_data}/firewalld/aio
%config %{_sysconfdir}/ovirt-engine-setup.conf.d/10-packaging-aio.conf


%files dbscripts
%{engine_data}/dbscripts


%files restapi

# Jar files:
%{engine_java}/interface-common-jaxrs.jar
%{engine_java}/restapi-definition.jar
%{engine_java}/restapi-jaxrs.jar
%{engine_java}/restapi-types.jar

# POM files:
%if %{install_poms}
%{_mavenpomdir}/JPP.%{name}-interface-common-jaxrs.pom
%{_mavenpomdir}/JPP.%{name}-restapi-definition.pom
%{_mavenpomdir}/JPP.%{name}-restapi-jaxrs.pom
%{_mavenpomdir}/JPP.%{name}-restapi-parent.pom
%{_mavenpomdir}/JPP.%{name}-restapi-types.pom
%endif

# Everything inside of the web application is owned by this
# subpackage:
%{restapi_war}


%files webadmin-portal
%{engine_ear}/webadmin.war


%files websocket-proxy
%dir %{engine_etc}/ovirt-websocket-proxy.conf.d
%{engine_data}/conf/ovirt-websocket-proxy.conf.defaults
%{engine_data}/services/ovirt-websocket-proxy.*
%{engine_data}/services/config.py*
%{engine_data}/services/service.py*

# Files needed by the service:
%if %{install_systemd}
%{_unitdir}/ovirt-websocket-proxy.service
%endif
%if %{install_systemv}
%{_initddir}/ovirt-websocket-proxy
%endif


%files tools

# Scripts:
%{engine_data}/bin/engine-config.sh
%{engine_data}/bin/engine-manage-domains.sh
%{engine_data}/bin/engine-prolog.sh

# Links to the scripts:
%{_bindir}/engine-config
%{_bindir}/engine-manage-domains

# Branded version of the links:
%{_bindir}/rhsc-config
%{_bindir}/rhsc-manage-domains

# Man pages:
%{_mandir}/man8/engine-manage-domains.*

# Configuration files for the configuration tool:
%dir %{engine_etc}/engine-config
%config(noreplace) %{engine_etc}/engine-config/engine-config.conf
%{engine_etc}/engine-config/engine-config.*properties
%{engine_etc}/engine-config/log4j.xml

# Configuration files for the domain management tool:
%dir %{engine_etc}/engine-manage-domains
%config(noreplace) %{engine_etc}/engine-manage-domains/engine-manage-domains.conf
%{engine_etc}/engine-manage-domains/log4j.xml

# Configuration files for the notifier:
%dir %{engine_etc}/notifier
%ghost %config(noreplace) %{engine_etc}/notifier/notifier.conf
%dir %{engine_etc}/notifier/notifier.conf.d
%config %{engine_etc}/notifier/log4j.xml
%{engine_data}/services/ovirt-engine-notifier.*

# Jar files:
%{engine_java}/tools.jar

# Config files:
%{engine_data}/conf/jaas.conf
%{engine_data}/conf/notifier.conf.defaults

# POM files:
%if %{install_poms}
%{_mavenpomdir}/JPP.%{name}-tools.pom
%endif

# Log and state directories must be owned by ovirt because the notifier service
# runs with that user and needs to write them:
%dir %attr(-, %{engine_user}, %{engine_group}) %{engine_log}/notifier
%dir %attr(-, %{engine_user}, %{engine_group}) %{engine_run}/notifier

# Files needed by the service:
%if %{install_systemd}
%{_unitdir}/ovirt-engine-notifier.service
%endif
%if %{install_systemv}
%{_initddir}/ovirt-engine-notifier
%endif

%changelog
* Mon Feb 18 2013 Shireesh Anjal <sanjal@redhat.com> - 2.1.0-0.qa6
- RHS-C branding

* Thu Jan 17 2013 Juan Hernandez <juan.hernandez@redhat.com> - 3.3.0-1
- Bump version to 3.3.0

* Fri Nov 02 2012 Juan Hernandez <juan.hernandez@redhat.com> - 3.2.0-1
- Bump version to 3.2.0

* Mon May 07 2012 Keith Robertson <kroberts@redhat.com> - 3.1.0-3
- Removed image uploader, iso uploader, and log collector from this
  git repo.  The are now in their own respective ovirt.org git
  repos. BZ#803240.

* Wed Apr 04 2012 Stephen Gordon <sgordon@redhat.com> - 3.1.0-2
- The ovirt-engine spec file did not previously contain a BuildRequires
  statement for the maven package. As a result in mock environments the
  build failed with an error when attempting to call the 'mvn' binary -
  BZ#807761.

* Wed Jan 04 2012 Ronen Angluste <ranglust@redhat.com> - 3.1.0-1
- Adjust code for Jboss AS 7.1

* Sun Dec 11 2011 Ronen Angluster <ranglust@redhat.com> - 3.1.0-1
- Moved all hard coded paths to macros

* Wed Oct 26 2011 Ronen Angluster <ranglust@redhat.com> - 3.1.0-1
- Initial build
- Cloned from RHEVM spec file
